#include "stdio.h"
#include "time.h"

// bestimmt anhand von 100.000.000.000 Rechenoperationen
// die Rechenzeit einer Subtraktion, Multiplikation, Division im
// Vergleich zur Addition

int main()
{
  double i;
  long t1, t2, t3, t4, t5, t6;

  time( &t1 );
  for( i=0; i<12499999999.999; i+=0.125 );
  time( &t2 );
  printf( "100.000.000.000 Additionen ergaben %lf\n"
          "Zeit: %ld Sekunden\n", i, t2 - t1 );

  time( &t3 );
  for( i=0; i<24999999999.999; i+=0.125 ) i += 0.125;
  time( &t4 );
  printf( "200.000.000.000 Additionen ergaben %lf\n"
          "Zeit: %ld Sekunden\n", i, t4 - t3 );

  t3 = t4 - t3 - t2 + t1; // Zeit für die Additionen (ohne Schleifenzeit)
  t4 = t2 - t1 - t3; // Schleifenzeit

  time( &t5 );
  for( i=12500000000.999; i>1; i-=0.125 );
  time( &t6 );
  printf( "100.000.000.000 Subtraktionen ergaben %lf\n"
          "Zeit: %ld Sekunden\n", i, t6 - t5 );
  printf( "Eine Subtraktion benötigt so viel Zeit wie %lf "
          "Additionen.\n",
          ((double)(t6 - t5 - t4)) / ((double)(t3)) );
  time( &t5 );
  // Die Schleifengrenzen wurden experimentell bestimmt, indem die
  // Anzahl der tatsächlichen Schleifendurchläufe gezählt wurde
  for( i=1e+218; i>5.07590805e-217; i*=0.99999999 );
  time( &t6 );
  printf( "100.000.000.000 Multiplikationen ergaben %lf\n"
          "Zeit: %ld Sekunden\n", i, t6 - t5 );
  printf( "Eine Multiplikation benötigt so viel Zeit wie %lf "
          "Additionen.\n",
          ((double)(t6 - t5 - t4)) / ((double)(t3)) );

  time( &t5 );
  for( i=5.07590805e-217; i<1e+218; i/=0.99999999 );
  time( &t6 );
  printf( "100.000.000.000 Divisionen ergaben %lf\n"
          "Zeit: %ld Sekunden\n", i, t6 - t5 );
  printf( "Eine Division benötigt so viel Zeit wie %lf Additionen.\n",
          ((double)(t6 - t5 - t4)) / ((double)(t3)) );

  return 0;
}
