// Optimierungsroutinen moldable, kein Modulabhängigkeitsgraph;
// Verwendung vom "BMZ" - Einfügealgorithmus
// optimiert Module deren Laufzeiten in der Datei daten stehen
// (i-te Zeile j-te Spalte enthält Laufzeit vom i-ten Modul
//  mit j Prozessoren)
// oder mit Hilfe der übergebenen Funktion laufzeit
// (modulnummer>=1, prozessorenanzahl>=1) ermittelt werden können
//
// Aufruf: optimiere_datei( char* ergebnisdateiname,
//                          char* datendateiname )
//   oder: optimiere_formel( char*  ergebnisdateiname,
//                           int    gesamtmodulanzahl,
//                           int    gesamtprozessorenanzahl,
//                           double ((*laufzeit)( modulnummer,
//                                                prozessorenanzahl )) )
//
// Fehler: 1->Eingabedatei fehlerhaft
//         2->zu wenig Speicher
//         3->kann Ergebnisdatei nicht anlegen
//         4->Eingabedatei nicht gefunden
//         5->Fehler bei Arbeit mit Hilfsdatei

#ifndef FORMEL
int optimiere_datei(
  char* ergebnis,
  char* daten );
#endif

#ifdef FORMEL
int optimiere_formel(
  char* ergebnis,
  int m,
  int n,
  double ((*laufzeit)( int modulnummer, int prozessorenanzahl )) );
#endif
