// Routine zum Erzeugen von Beispielen:
//   kein Abhängigkeitsgraph, non-moldable
// der Wert 0.0 als Laufzeit im Ergebnis steht für Laufzeit unendlich,
// also nicht möglich
//
// Aufruf:
// baue_bsp_datei(
//   char* Filename_für_Ergebnis,
//   char* Filename_Eingabedatei );
//
// oder:
// baue_bsp_array(
//   double** Laufzeiten der Module,
//   int*     Modulanzahl,
//   int*     Prozessorenanzahl,
//   char*    Filename_Eingabedatei );
//
// Fehler: 1->zu wenig Speicher
//         2->konnte Ergebnisdatei nicht anlegen
//         3->nicht genug Einträge im Listenfeld / Fehler in Datei
//         4->konnte Eingabedatei nicht finden

int baue_bsp_datei(
  char* fn,
  char* fin );

int baue_bsp_array(
  double** laufz,
  int*     m,
  int*     n,
  char*    fin );

// --------------------------- weitere Routinen ------------------------

// reserviert den maximal benötigten Speicher für eine Laufzeittabelle
// Fehler: 1->zu wenig Speicher
//         2->Configdatei nicht gefunden
//         3->Configdatei fehlerhaft
int init_laufzeit( double*** laufz, char* fn );

// gibt Speicher der Laufzeittabelle frei
// Fehler: 1->Configdatei nicht gefunden
//         2->Configdatei fehlerhaft
int frei_laufzeit( double** laufz, char* fn );
