// Optimierungsroutinen moldable,
// Modulabhängigkeitsgraph ist ein serien-paralleler Graph
// optimiert Module deren Laufzeiten in der Datei daten stehen
// (i-te Zeile j-te Spalte enthält Laufzeit vom i-ten Modul
//  mit j Prozessoren)
// oder mit Hilfe der übergebenen Funktion
// laufzeit (modulnummer>=1, prozessorenanzahl>=1) ermittelt
// werden können
//
// Aufruf:
//   optimiere_datei(
//     char* ergebnis_datei,
//     char* laufzeit_daten_datei,
//     char* modulabhängigkeitsgraph_datei )
// oder:
//   optimiere_formel(
//     double** startzeit_der_module,
//     int**    prozessoranzahl_der_module,
//     int**    kleinste_prozessornummer_der_module,
//     graph*   modulabhängigkeitsgraph,
//     int      maximalprozessoranzahl,
//     double   ((*laufzeit)( modulnummer, prozessorenanzahl )) )
//
//   Speicher für Rückgabewerte startzeit_der_module,
//   prozessoranzahl_der_module und kleinste_prozessornummer_der_module
//   wird reserviert
//
// Fehler: 1->zu wenig Speicher
//         2->Eingabedatei mit Laufzeiten nicht gefunden / fehlerhaft
//         3->Eingabedatei mit Graphen nicht gefunden / fehlerhaft
//         4->kann Ergebnisdatei nicht anlegen / Schreibfehler

#ifndef FORMEL
int optimiere_datei(
  char* ergebnis,
  char* daten,
  char* graph_datei );
#endif

#ifdef FORMEL
int optimiere_formel(
  double** startzeit,
  int**    breite,
  int**    linker,
  graph*   g,
  int      n,
  double   ((*laufzeit)( int modulnummer, int prozessorenanzahl )) );
#endif
