// Optimierungsroutinen non-moldable,
// Modulabhängigkeitsgraph ist ein serien-paralleler Graph
// optimiert Module deren Laufzeiten in der Datei daten stehen
// (i-te Zeile j-te Spalte enthält Laufzeit vom i-ten Modul
//  mit j Prozessoren)
// und deren Abhängigkeitsgraph in der graphendatei steht
// (jede Zeile hat den folgenden Aufbau: x y1 y2 y3 ... bedeutet,
//  daß x erst nach Beendigung von y1, y2, y3, ... ausgeführt werden
//  darf)
// oder
// mit Hilfe der übergebenen Funktion 
// laufzeit (modulnummer>=1, prozessorenanzahl>=1)
// ermittelt werden können
//
// Aufruf:
//   optimiere_datei(
//     char* ergebnis,
//     char* daten,
//     char* graphendatei )
// oder:
//   optimiere_formel(
//     double** startzeit,
//     int**    breite,
//     int**    linker,
//     graph*   modulabhängigkeitsgraph,
//     int      maximalprozessorenanzahl,
//     double   ((*laufzeit)( modulnummer, prozessorenanzahl )) )
//   Speicher für startzeit, breite und linker wird reserviert
//
// Fehler: 1->zu wenig Speicher
//         2->Eingabedatei mit Laufzeiten nicht gefunden / fehlerhaft
//         3->Eingabedatei mit Graphen nicht gefunden / fehlerhaft
//         4->kann Ergebnisdatei nicht anlegen / Schreibfehler

#include "../prgx/graphen.h"

#ifndef FORMEL
int optimiere_datei(
  char* ergebnis,
  char* daten,
  char* graph_datei );
#endif

#ifdef FORMEL
int optimiere_formel(
  double** startzeit,
  int**    breite,
  int**    linker,
  graph*   g,
  int      n,
  double   ((*laufzeit)( int modulnummer, int prozessorenanzahl )) );
#endif

