#include <math.h>

int convert_string2double_varint_help1(
  char*   a,
  char*   var_name,
  int*    var_wert,
  int*    i,
  double* erg ); // Vorwärtsdeklaration (Variablen als int)

// Hilfsroutine für convert_string2double_varint (Variablen als int)
int convert_string2double_varint_help4(
  char*   a,
  char*   var_name,
  int*    var_wert,
  int*    i,
  double* erg )
{
  int j;
  double min;
  while( ( a[*i] == ' ' )  ||
         ( a[*i] == '\t' ) ||
         ( a[*i] == '\n' ) ) // Leerzeichen überlesen
  {
    (*i)++;
  }
  // einfache Zahl
  if( ( ( a[*i] >= '0' ) && ( a[*i] <= '9' ) ) || ( a[*i] == '.' ) )
  {
    if( a[*i] == '.' )
    {
      *erg = 0;
      j = 0;
    }
    else
    {
      *erg = a[*i] - '0';
      j = -1;
    }
    (*i)++;
    while( 1 )
    {
      if( ( a[*i] >= '0' ) && ( a[*i] <= '9' ) )
      {
        *erg *= 10;
        *erg += a[*i] - '0';
        if( j != -1 )
        {
          j++;
        }
      }
      else
      {
        if( ( a[*i] == '.' ) && ( j == -1 ) )
        {
          j = 0;
        }
        else
        {
          while( j > 0 )
          {
            j--;
            *erg /= 10;
          }
          if( a[*i] == 'e' )
          {
            (*i)++;
            if( a[*i] == '-' )
            {
              (*i)++;
              if( ( a[*i] < '0' ) || ( a[*i] > '9' ) )
              {
                return 1;
              }
              j = a[*i] - '0';
              (*i)++;
              while( ( a[*i] >= '0' ) && ( a[*i] <= '9' ) )
              {
                j *= 10;
                j += a[*i] - '0';
                (*i)++;
              }
              while( j > 0 )
              {
                j--;
                *erg /= 10;
              }
              return 0;
            }
            if( a[*i] == '+' )
            {
              (*i)++;
            }
            if( ( a[*i] < '0' ) || ( a[*i] > '9' ) )
            {
              return 1;
            }
            j = a[*i] - '0';
            (*i)++;
            while( ( a[*i] >= '0' ) && ( a[*i] <= '9' ) )
            {
              j *= 10;
              j += a[*i] - '0';
              (*i)++;
            }
            while( j > 0 )
            {
              j--;
              *erg *= 10;
            }
            return 0;
          }
          else
          {
            return 0;
          }
        }
      }
      (*i)++;
    }
  }
  // Unterausdruck
  if( a[*i] == '(' )
  {
    (*i)++;
    j = convert_string2double_varint_help1( a, var_name, var_wert,
                                            i, erg );
    if( j != 0 )
    {
      return j;
    }
    if( a[*i] != ')' )
    {
      return 1;
    }
    (*i)++;
    return 0;
  }
  // abrunden
  if( a[*i] == '[' )
  {
    (*i)++;
    j = convert_string2double_varint_help1( a, var_name, var_wert,
                                            i, erg );
    if( j != 0 )
    {
      return j;
    }
    if( a[*i] != ']' )
    {
      return 1;
    }
    (*i)++;
    *erg = floor( *erg );
    return 0;
  }
  // Minimum der durch ';' getrennten Ausdrücke bestimmen
  if( a[*i] == '{' )
  {
    (*i)++;
    j = convert_string2double_varint_help1( a, var_name, var_wert,
                                            i, erg );
    if( j != 0 )
    {
      return j;
    }
    while( a[*i] == ';' ) // ';' oder '}' ?
    {
      (*i)++;
      j = convert_string2double_varint_help1( a, var_name, var_wert,
                                              i, &min );
      if( j != 0 )
      {
        return j;
      }
      if( min < *erg )
      {
        *erg = min;
      }
    }
    if( a[*i] != '}' )
    {
      return 1;
    }
    (*i)++;
    return 0;
  }
  // Variable
  if( ( ( a[*i] >= 'a' ) && ( a[*i] <= 'z' ) ) ||
      ( ( a[*i] >= 'A' ) && ( a[*i] <= 'Z' ) ) )
  {
    j = 0;
    while( var_name[j] != '\0' )
    {
      if( var_name[j] == a[*i] )
      {
        *erg = (double)(var_wert[j]);
        while( ( ( a[*i] >= 'a' ) && ( a[*i] <= 'z' ) ) ||
               ( ( a[*i] >= 'A' ) && ( a[*i] <= 'Z' ) ) ||
               ( ( a[*i] >= '0' ) && ( a[*i] <= '9' ) ) )
        { // nachfolgende Buchstaben und Zahlen überlesen
          (*i)++;
        }
        return 0;
      }
      j++;
    }
    return 2; // Variable unbekannt
  }
  if( a[*i] == '-' ) // unäres Minus
  {
    (*i)++;
    j = convert_string2double_varint_help4( a, var_name, var_wert,
                                            i, erg );
    if( j != 0 )
    {
      return j;
    }
    *erg = -(*erg);
    return 0;
  }
  // Fehler
  return 1;
}

// Hilfsroutine für convert_string2double_varint (Variablen als int)
int convert_string2double_varint_help3(
  char*   a,
  char*   var_name,
  int*    var_wert,
  int*    i,
  double* erg )
{
  int j;
  double e;
  j = convert_string2double_varint_help4( a, var_name, var_wert,
                                          i, erg );
  if( j != 0 )
  {
    return j;
  }
  while( ( a[*i] == ' ' )  ||
         ( a[*i] == '\t' ) ||
         ( a[*i] == '\n' ) ) // Leerzeichen überlesen
  {
    (*i)++;
  }
  while( 1 )
  {
    // Potenzieren
    if( a[*i] == '^' )
    {
      (*i)++;
      j = convert_string2double_varint_help4( a, var_name, var_wert,
                                              i, &e );
      if( j != 0 )
      {
        return j;
      }
      if( *erg != 0.0 )
      {
        *erg = pow( *erg, e );
      }
    }
    else
    {
      // keine Potenzbildung
      return 0;
    }
    while( ( a[*i] == ' ' )  ||
           ( a[*i] == '\t' ) ||
           ( a[*i] == '\n' ) ) // Leerzeichen überlesen
    {
      (*i)++;
    }
  }
}

// Hilfsroutine für convert_string2double_varint (Variablen als int)
int convert_string2double_varint_help2(
  char*   a,
  char*   var_name,
  int*    var_wert,
  int*    i,
  double* erg )
{
  int j;
  double e;
  j = convert_string2double_varint_help3( a, var_name, var_wert,
                                          i, erg );
  if( j != 0 )
  {
    return j;
  }
  while( ( a[*i] == ' ' )  ||
         ( a[*i] == '\t' ) ||
         ( a[*i] == '\n' ) ) // Leerzeichen überlesen
  {
    (*i)++;
  }
  while( 1 )
  {
    // Multiplikation
    if( a[*i] == '*' )
    {
      (*i)++;
      j = convert_string2double_varint_help3( a, var_name, var_wert,
                                              i, &e );
      if( j != 0 )
      {
        return j;
      }
      *erg *= e;
    }
    else
    {
      // Division
      if( a[*i] == '/' )
      {
        (*i)++;
        j = convert_string2double_varint_help3( a, var_name, var_wert,
                                                i, &e );
        if( j != 0 )
        {
          return j;
        }
        *erg /= e;
      }
      else
      {
        // keine Punkt-Operation
        return 0;
      }
    }
    while( ( a[*i] == ' ' )  ||
           ( a[*i] == '\t' ) ||
           ( a[*i] == '\n' ) ) // Leerzeichen überlesen
    {
      (*i)++;
    }
  }
}

// Hilfsroutine für convert_string2double_varint (Variablen als int)
int convert_string2double_varint_help1(
  char*   a,
  char*   var_name,
  int*    var_wert,
  int*    i,
  double* erg )
{
  int j;
  double e;
  j = convert_string2double_varint_help2( a, var_name, var_wert,
                                          i, erg );
  if( j != 0 )
  {
    return j;
  }
  while( ( a[*i] == ' ' )  ||
         ( a[*i] == '\t' ) ||
         ( a[*i] == '\n' ) ) // Leerzeichen überlesen
  {
    (*i)++;
  }
  while( a[*i] != '\0' )
  {
    // Addition
    if( a[*i] == '+' )
    {
      (*i)++;
      j = convert_string2double_varint_help2( a, var_name, var_wert,
                                              i, &e );
      if( j != 0 )
      {
        return j;
      }
      *erg += e;
    }
    else
    {
      // Subtraktion
      if( a[*i] == '-' )
      {
        (*i)++;
        j = convert_string2double_varint_help2( a, var_name, var_wert,
                                                i, &e );
        if( j != 0 )
        {
          return j;
        }
        *erg -= e;
      }
      else
      {
        // keine Strich-Operation
        if( ( a[*i] == ')' ) ||
            ( a[*i] == ']' ) ||
            ( a[*i] == ';' ) ||
            ( a[*i] == '}' ) )
        {
          return 0;
        }
        else
        {
          return 1;
        }
      }
    }
    while( ( a[*i] == ' ' )  ||
           ( a[*i] == '\t' ) ||
           ( a[*i] == '\n' ) ) // Leerzeichen überlesen
    {
      (*i)++;
    }
  }
  return 0;
}

// berechnet den Wert erg eines Strings a mit
// Rechenoperationen und Klammern (Variablen als int)
// Minimumsuche mittels {a;b;c} und abrunden durch [x]
// Variablen werden nur am ersten Buchstaben erkannt;
// Unterscheidung von groß/klein
// in var_wert[i] steht der Wert der Variable var_name[i]
// Fehler: 1->Syntaxfehler
//         2->Variable unbekannt
int convert_string2double_varint(
  char*   a,
  char*   var_name,
  int*    var_wert,
  double* erg )
{
  int i, j;
  i = 0; // aktuelle Position
  j = convert_string2double_varint_help1( a, var_name, var_wert,
                                          &i, erg );
  if( j != 0 )
  {
    return j;
  }
  if( a[i] != '\0' ) // zu viel schließende Klammern
  {
    return 1;
  }
  return 0;
}

int convert_string2int_help1(
  char* a,
  char* var_name,
  int*  var_wert,
  int*  i,
  int*  erg ); // Vorwärtsdeklaration

// Hilfsroutine für convert_string2int
int convert_string2int_help4(
  char* a,
  char* var_name,
  int*  var_wert,
  int*  i,
  int*  erg )
{
  int j;
  double d;
  int min;
  while( ( a[*i] == ' ' )  ||
         ( a[*i] == '\t' ) ||
         ( a[*i] == '\n' ) ) // Leerzeichen überlesen
  {
    (*i)++;
  }
  // einfache Zahl
  if( ( a[*i] >= '0' ) && ( a[*i] <= '9' ) )
  {
    *erg = a[*i] - '0';
    (*i)++;
    while( ( a[*i] >= '0' ) && ( a[*i] <= '9' ) )
    {
      *erg *= 10;
      *erg += a[*i] - '0';
      (*i)++;
    }
    return 0;
  }
  // Unterausdruck
  if( a[*i] == '(' )
  {
    (*i)++;
    j = convert_string2int_help1( a, var_name, var_wert, i, erg );
    if( j != 0 )
    {
      return j;
    }
    if( a[*i] != ')' )
    {
      return 1;
    }
    (*i)++;
    return 0;
  }
  // abrunden -> umschalten auf double
  if( a[*i] == '[' )
  {
    (*i)++;
    j = convert_string2double_varint_help1( a, var_name,
                                            var_wert, i, &d );
    if( j != 0 )
    {
      return j;
    }
    if( a[*i] != ']' )
    {
      return 1;
    }
    (*i)++;
    if( d < 0 )
    {
      *erg = 0;
      return 0;
    }
    *erg = d;
    return 0;
  }
  // Minimum der durch ';' getrennten Ausdrücke bestimmen
  if( a[*i] == '{' )
  {
    (*i)++;
    j = convert_string2int_help1( a, var_name, var_wert, i, erg );
    if( j != 0 )
    {
      return j;
    }
    while( a[*i] == ';' ) // ';' oder '}' ?
    {
      (*i)++;
      j = convert_string2int_help1( a, var_name, var_wert, i, &min );
      if( j != 0 )
      {
        return j;
      }
      if( min < *erg )
      {
        *erg = min;
      }
    }
    if( a[*i] != '}' )
    {
      return 1;
    }
    (*i)++;
    return 0;
  }
  // Variable
  if( ( ( a[*i] >= 'a' ) && ( a[*i] <= 'z' ) ) ||
      ( ( a[*i] >= 'A' ) && ( a[*i] <= 'Z' ) ) )
  {
    j = 0;
    while( var_name[j] != '\0' )
    {
      if( var_name[j] == a[*i] )
      {
        *erg = var_wert[j];
        while( ( ( a[*i] >= 'a' ) && ( a[*i] <= 'z' ) ) ||
               ( ( a[*i] >= 'A' ) && ( a[*i] <= 'Z' ) ) ||
               ( ( a[*i] >= '0' ) && ( a[*i] <= '9' ) ) )
        { // nachfolgende Buchstaben und Zahlen überlesen
          (*i)++;
        }
        return 0;
      }
      j++;
    }
    return 2; // Variable unbekannt
  }
  if( a[*i] == '-' ) // unäres Minus
  {
    (*i)++;
    j = convert_string2int_help4( a, var_name, var_wert, i, erg );
    if( j != 0 )
    {
      return j;
    }
    *erg = -(*erg);
    return 0;
  }
  // Fehler
  return 1;
}

// Hilfsroutine für convert_string2int
int convert_string2int_help3(
  char* a,
  char* var_name,
  int*  var_wert,
  int*  i,
  int*  erg )
{
  int j;
  int e;
  j = convert_string2int_help4( a, var_name, var_wert, i, erg );
  if( j != 0 )
  {
    return j;
  }
  while( ( a[*i] == ' ' )  ||
         ( a[*i] == '\t' ) ||
         ( a[*i] == '\n' ) ) // Leerzeichen überlesen
  {
    (*i)++;
  }
  while( 1 )
  {
    // Potenzieren
    if( a[*i] == '^' )
    {
      (*i)++;
      j = convert_string2int_help4( a, var_name, var_wert, i, &e );
      if( j != 0 )
      {
        return j;
      }
      if( *erg != 0 )
      {
        *erg = ((int)(pow( ((double)(*erg)),
                           ((double)(e)) ) + 0.5));
      }
    }
    else
    {
      // keine Potenzbildung
      return 0;
    }
    while( ( a[*i] == ' ' )  ||
           ( a[*i] == '\t' ) ||
           ( a[*i] == '\n' ) ) // Leerzeichen überlesen
    {
      (*i)++;
    }
  }
}

// Hilfsroutine für convert_string2int
int convert_string2int_help2(
  char* a,
  char* var_name,
  int*  var_wert,
  int*  i,
  int*  erg )
{
  int j;
  int e;
  j = convert_string2int_help3( a, var_name, var_wert, i, erg );
  if( j != 0 )
  {
    return j;
  }
  while( ( a[*i] == ' ' )  ||
         ( a[*i] == '\t' ) ||
         ( a[*i] == '\n' ) ) // Leerzeichen überlesen
  {
    (*i)++;
  }
  while( 1 )
  {
    // Multiplikation
    if( a[*i] == '*' )
    {
      (*i)++;
      j = convert_string2int_help3( a, var_name, var_wert, i, &e );
      if( j != 0 )
      {
        return j;
      }
      *erg *= e;
    }
    else
    {
      // Division
      if( a[*i] == '/' )
      {
        (*i)++;
        j = convert_string2int_help3( a, var_name, var_wert, i, &e );
        if( j != 0 )
        {
          return j;
        }
        *erg /= e;
      }
      else
      {
        // keine Punkt-Operation
        return 0;
      }
    }
    while( ( a[*i] == ' ' )  ||
           ( a[*i] == '\t' ) ||
           ( a[*i] == '\n' ) ) // Leerzeichen überlesen
    {
      (*i)++;
    }
  }
}

// Hilfsroutine für convert_string2int
int convert_string2int_help1(
  char* a,
  char* var_name,
  int*  var_wert,
  int*  i,
  int*  erg )
{
  int j;
  int e;
  j = convert_string2int_help2( a, var_name, var_wert, i, erg );
  if( j != 0 )
  {
    return j;
  }
  while( ( a[*i] == ' ' )  ||
         ( a[*i] == '\t' ) ||
         ( a[*i] == '\n' ) ) // Leerzeichen überlesen
  {
    (*i)++;
  }
  while( a[*i] != '\0' )
  {
    // Addition
    if( a[*i] == '+' )
    {
      (*i)++;
      j = convert_string2int_help2( a, var_name, var_wert, i, &e );
      if( j != 0 )
      {
        return j;
      }
      *erg += e;
    }
    else
    {
      // Subtraktion (kleinster Wert ist 0)
      if( a[*i] == '-' )
      {
        (*i)++;
        j = convert_string2int_help2( a, var_name, var_wert, i, &e );
        if( j != 0 )
        {
          return j;
        }
        if( *erg > e )
        {
          *erg -= e;
        }
        else
        {
          *erg = 0;
        }
      }
      else
      {
        // keine Strich-Operation
        if( ( a[*i] == ')' ) ||
            ( a[*i] == ';' ) ||
            ( a[*i] == '}' ) )
        {
          return 0;
        }
        else
        {
          return 1;
        }
      }
    }
    while( ( a[*i] == ' ' )  ||
           ( a[*i] == '\t' ) ||
           ( a[*i] == '\n' ) ) // Leerzeichen überlesen
    {
      (*i)++;
    }
  }
  return 0;
}

// berechnet den Wert erg eines Strings a mit
// Rechenoperationen und Klammern (ganzzahlige Division,
// Subtraktion mit Minimum 0)
// Minimumsuche mittels {a;b;c} und abrunden durch [x]
// (x wird dann als double berechnet)
// Variablen werden nur am ersten Buchstaben erkannt;
// Unterscheidung von groß/klein
// in var_wert[i] steht der Wert der Variable var_name[i]
// Fehler: 1->Syntaxfehler
//         2->Variable unbekannt
int convert_string2int_var(
  char* a,
  char* var_name,
  int*  var_wert,
  int*  erg )
{
  int i, j;
  i = 0; // aktuelle Position
  j = convert_string2int_help1( a, var_name, var_wert, &i, erg );
  if( j != 0 )
  {
    return j;
  }
  if( a[i] != '\0' ) // zu viel schließende Klammern
  {
    return 1;
  }
  return 0;
}
